/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.human.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.action.MosPHumanAction;

import jp.mosp.human.dto.MEmergencyDto;
import jp.mosp.human.dto.MKihonDto;
import jp.mosp.human.dto.MKojinDto;
import jp.mosp.human.vo.HumanPersonalCardVo;

public class HumanPersonalCardAction extends MosPHumanAction {

	// コマンド
	private static final String CMD_HUMAN_PERSONAL_SELECT    = "H1030";
	private static final String CMD_HUMAN_PERSONAL_UPDATE    = "H1033";	

	// フィールド
	private MKojinDto 		storedmKojinDto;
	private MEmergencyDto 	storedmEmergencyDto;

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// HUMAN権限確認
		confirmHumanAuth();
		// VOの取得
		HumanPersonalCardVo vo = getInitVo();
		// 初期処理
		init(vo);
		// プルダウン設定 
		setPulldownList(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_HUMAN_PERSONAL_SELECT)) {
			// 表示(社員コードで情報を検索)
			select(vo);
		}  else if (cmd.equals(CMD_HUMAN_PERSONAL_UPDATE)) {
			// 更新
			update(vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	protected HumanPersonalCardVo getInitVo() {
		return new HumanPersonalCardVo();
	}

	/**
	 * 初期処理
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void init(HumanPersonalCardVo vo) throws Exception {
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// パラメータ取得
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// 性別リスト取得
		vo.aryPltGender = getMosPCodeArray(CommonConst.TID_SEIBETSU);
		// 生年月日リスト取得
		Date date = util.getSystemDate();
		vo.aryPltBirthYear = util.getYearArray(MospUtility.getYear (date), 50, 1);
		vo.aryPltBirthMonth = util.getMonthArray();
		vo.aryPltBirthDay = util.getDayArray();
		// ボタン内容設定
		setListButton(vo);
	}

	/**
	 * プルダウン設定
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void setPulldownList(HumanPersonalCardVo vo) throws Exception {
		// 県リスト取得
		vo.aryPltPrefecture = CommonConst.getPrefectureArray(); 
		// 血液型リスト
		vo.aryPltBloodType = getMosPCodeArray(CommonConst.TID_BLOOD_TYPE);
		// 給与区分
		vo.aryPltSalaryKb = getMosPCodeArray(CommonConst.TID_SALARY);
		// 税区分
		vo.aryPltTaxKb = getMosPCodeArray(CommonConst.TID_TAX);
		// 組合区分
		vo.aryPltUnionKb = getMosPCodeArray(CommonConst.TID_UNION);
		// 支払い区分
		vo.aryPltPaymentKb = getMosPCodeArray(CommonConst.TID_PAYMENT);
		// パート区分
		vo.aryPltPartKb = getMosPCodeArray(CommonConst.TID_PARTTIME);
	}

	/**
	 * データ表示
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void select(HumanPersonalCardVo vo) throws Exception {
		// 選択社員コード取得
		String kCode = "";
		if (vo.getTxtChangeKCode() != null && !vo.getTxtChangeKCode().equals("") ) {
			kCode = vo.getTxtChangeKCode();
		} else if (key1 != null && !key1.equals("")) {
			kCode = key1;
		}
		// 人事基本情報取得
		getHumanKihonInfo(kCode, vo);
		// 個人情報取得
		getHumanKojinInfo(kCode, vo);
		// 緊急連絡先取得処理
		getHumanmEmergencyInfo(kCode, vo);
		// 表示用人事基本情報設定
		vo.setLblKCode(kCode);
		vo.setLblKName(mKihonDto.getSimei());
		vo.setLblKKana(mKihonDto.getFurigana());
		// セッションにDTOをセット
		setStoredDto();
	}

	/**
	 * 更新処理
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void update(HumanPersonalCardVo vo) throws Exception {
		// セッション保持DTO取得
		getStoredDto();
		// パラメータの妥当性確認
		vo.validate();
		// DAO準備
		prepareHumanBasisDao();
		prepareKojinBasisDao();
		prepareEmergencyBasisDao();
		// 登録処理
		String message = regist(vo);
		// コミット
		commit();
		// 人事基本情報取得
		getHumanKihonInfo(vo.getTxtChangeKCode(), vo);
		getHumanKojinInfo(vo.getTxtChangeKCode(), vo);
		getHumanmEmergencyInfo(vo.getTxtChangeKCode(), vo);
		// メッセージ設定
		vo.setMessage(message);
		// 表示用人事基本情報設定
		vo.setLblKCode(vo.getTxtChangeKCode());
		vo.setLblKName(mKihonDto.getSimei());
		vo.setLblKKana(mKihonDto.getFurigana());
		// セッションにDTOをセット
		setStoredDto();
	}

	/**
	 * 情報取得処理
	 * @param kCode 取得対象社員コード
	 * @param vo    情報設定対象VO
	 * @throws Exception
	 */
	private void getHumanKihonInfo(String kCode, HumanPersonalCardVo vo) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// 人事基本情報取得
		findHumanBasisInfo(kCode, false);
		// 対象データ存在確認
		if (mKihonDto == null) {
			addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_NO_HUMAN_DATA, ""));
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mKihonDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);				
		// セッション保持用DTO設定
		storedmKihonDto = mKihonDto;
		// 排他情報設定
		String editor = setExclusive(CommonConst.EXC_HUMAN_BASIS, user.getUserId(), kCode);
		if (editor != null) {
			addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_EXCLUSIVE, editor));
		}
		setNeedExclusive(true);
	}

	/**
	 * 個人情報取得
	 * @param kCode 取得対象社員コード
	 * @param vo    情報設定対象VO
	 * @throws Exception
	 */
	private void getHumanKojinInfo(String kCode, HumanPersonalCardVo vo) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// 個人情報取得
		findHumanPersonnelInfo(kCode, false);
		// 対象データ存在確認
		if (mKojinDto == null) {
			mKojinDto = new MKojinDto();
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mKojinDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);		
		// セッション保持用DTO設定
		storedmKojinDto = mKojinDto;			
	}

	/**
	 * 緊急連絡先取得処理
	 * @param kCode 取得対象社員コード
	 * @param vo    情報設定対象VO
	 * @throws Exception
	 */
	private void getHumanmEmergencyInfo(String kCode, HumanPersonalCardVo vo) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// 緊急連絡先情報取得
		findHumanEmergencyInfo(kCode, false);
		// 対象データ存在確認
		if (mEmergencyDto == null) {
			mEmergencyDto = new MEmergencyDto();
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mEmergencyDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmEmergencyDto = mEmergencyDto;
	}

	/**
	 * セッション保持DTO取得
	 */
	protected void getStoredDto() {
		storedmKihonDto = (MKihonDto)session.getAttribute(CommonConst.ATT_MKIHON_DTO);
		storedmKojinDto = (MKojinDto)session.getAttribute("mKojinDto");
		storedmEmergencyDto = (MEmergencyDto)session.getAttribute("mEmergencyDto");
	}

	/**
	 * セッション保持DTO設定
	 */
	protected void setStoredDto() {
		session.setAttribute(CommonConst.ATT_MKIHON_DTO, storedmKihonDto);
		session.setAttribute("mKojinDto", storedmKojinDto);
		session.setAttribute("mEmergencyDto", storedmEmergencyDto);
	}

	/**
	 * 登録処理
	 * @param vo 対象VO
	 * @return メッセージ
	 * @throws Exception
	 */
	private String regist(
			HumanPersonalCardVo vo		
	) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// DTOの準備
		if (mKihonDto == null) {
			mKihonDto = storedmKihonDto;
		}
		vo.setDtoFields(mKihonDto);

		if (mKojinDto == null) {
			mKojinDto = new MKojinDto();
		}
		vo.setDtoFields(mKojinDto);

		if (mEmergencyDto == null) {
			mEmergencyDto = new MEmergencyDto();
		}
		vo.setDtoFields(mEmergencyDto);	
		mKojinDto.setKCode(mKihonDto.getKCode());
		// 人事基本情報存在確認
		String message = "";
		// 人事基本情報更新
		chkExclusive(mKihonDto, mKihonDao.findForUpdate(mKihonDto.getKCode()), vo);
		// 更新
		mKihonDao.update(mKihonDto);
		// 個人情報取得
		MKojinDto chkMKojinDto = mKojinDao.findForUpdate(vo.getTxtChangeKCode());		
		if (chkMKojinDto == null) {
			// 個人情報登録	
			mKojinDao.insert(mKojinDto);
		} else {
			// 個人情報更新
			mKojinDao.update(mKojinDto);
		}
		// 緊急連絡先情報取得		
		String maxEno =	mEmergencyDao.findForMax();
		if(maxEno == null || maxEno.equals("")){
			maxEno = "-1";
		} else {
			mEmergencyDao.findForUpdate(maxEno);
		}
		if (mEmergencyDao.findForConditionUpdate(mKihonDto.getKCode()) != null) {
			storedmEmergencyDto.setDeleteFlag(1);
			// 緊急連絡先更新
			mEmergencyDao.update(storedmEmergencyDto);
		}
		// 最大値をセット
		mEmergencyDto.setEmCode(Integer.parseInt(maxEno) + 1);					
		// 緊急連絡先登録	
		mEmergencyDao.insert(mEmergencyDto);
		message = MospUtility.getMessage(msg, MospConst.MSG_UPDATE, "");
		return message;
	}

}
